SystemOrganization addCategory: #'Rizel-Tools'!

Object subclass: #RizelAbstractConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/18/2012 23:56'!
buildBenchmarks
	^ self class allSelectors
		select: [:selector | selector beginsWith: 'bench']! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/20/2012 00:08'!
executeBenchmark: aBlock 
	^ (self factor) timesRepeat: aBlock.! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/20/2012 00:08'!
factor
	^ 1! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/18/2012 23:53'!
loadVersion: version
	^ self subclassResponsability.! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/18/2012 23:54'!
open
	| browser |
	browser := Rizel new.
	browser model: self.
	browser benchmarks: self buildBenchmarks.
	browser openWithSpec.
	^ browser! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/19/2012 00:02'!
packageRegex
	^ self subclassResponsability.! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/19/2012 23:59'!
profile: benchmark in: version 
	self loadVersion: version.
	"cleaning memory"
	10 timesRepeat: [Smalltalk garbageCollect.].
	Object new. Object new.
	10 timesRepeat: [Smalltalk garbageCollect.].
	"cleaning memory"
	^ self profilerClass
		profile: [self executeBenchmark: [self perform:benchmark]]
		inPackagesMatching: (self packageRegex).! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/18/2012 23:52'!
profilerClass
	^ RzProfilerSpy! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/18/2012 23:56'!
versionLabel
	^ self subclassResponsability.! !

!RizelAbstractConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/18/2012 23:57'!
versions
	^ self subclassResponsability.! !

RizelAbstractConfig subclass: #RizelPackageConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RizelPackageConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/19/2012 01:27'!
loadVersion: versionName

	Gofer new url: (self url);
		 version: versionName;
		 load.! !

!RizelPackageConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/19/2012 01:15'!
parseName: aString
	| basicName package branch author versionNumber|
	basicName := aString last isDigit
		ifTrue: [ aString ]
		ifFalse: [ (aString copyUpToLast: $.) copyUpTo: $( ].
	package := basicName copyUpToLast: $-.
	(package includes: $.)
		ifFalse: [ branch := '' ]
		ifTrue: [
			branch := package copyAfter: $..
			package := package copyUpTo: $. ].
	author := (basicName copyAfterLast: $-) copyUpToLast: $..
	versionNumber := (basicName copyAfterLast: $-) copyAfterLast: $..
	(versionNumber notEmpty and: [ versionNumber allSatisfy: [ :each | each isDigit ] ])
		ifTrue: [ versionNumber := versionNumber asInteger ]
		ifFalse: [ versionNumber := 0 ].
	^ versionNumber asString.! !

!RizelPackageConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/19/2012 00:00'!
url
	^ self subclassResponsability.! !

!RizelPackageConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/19/2012 01:14'!
versionLabel
	^ [ :v| self parseName: v].! !

RizelAbstractConfig subclass: #RizelProjectConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RizelProjectConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/18/2012 23:53'!
configurationClass
	^ self subclassResponsability! !

!RizelProjectConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/18/2012 23:58'!
loadVersion: version
	version load.! !

!RizelProjectConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/20/2012 00:30'!
versionLabel
	^ [ :v| v versionNumber asString].! !

!RizelProjectConfig methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/20/2012 00:29'!
versions
	^ (((self configurationClass project 
						versions select:[ :v|  v importedVersions size >0]) reversed) asOrderedCollection).! !

ComposableModel subclass: #Rizel
	instanceVariableNames: 'versions benchmarks model options roassal benchs morphView profilePicker builder result versionLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!Rizel class methodsFor: 'spec' stamp: ''!
defaultSpec
	^ {#ComposableSpec. #add:. {{#model. #versions. #defaultSpec}. #layout:. {#FrameLayout. #fractions:offsets:. 0 @ 0.5 corner: 0.3 @ 1. 2 @ 10 corner: 2 @ 2}}. #add:. {{#model. #benchmarks. #defaultSpec}. #layout:. {#FrameLayout. #fractions:offsets:. 0 @ 0 corner: 0.3 @ 0.5. 2 @ 30 corner: 2 @ 2}}. #add:. {{#model. #options. #defaultSpec}. #layout:. {#FrameLayout. #fractions:offsets:. 0 @ 0 corner: 0.3 @ 0. 2 @ 25 corner: 2 @ 2}}. #add:. {{#model. #roassal. #defaultSpec}. #layout:. {#FrameLayout. #fractions:offsets:. 0.3 @ 0 corner: 1 @ 1. 0 @ 0 corner: 0 @ 0}}}! !

!Rizel class methodsFor: 'spec' stamp: ''!
openWith: t1 
	| t2 |
	t2 := Rizel new.
	t2 configurationModel: t1.
	t2 openWithSpec.
	^ t2! !

!Rizel class methodsFor: 'spec' stamp: ''!
title
	^ 'Rizel'! !

!Rizel methodsFor: 'accessing' stamp: ''!
addBench: t1 
	benchs add: t1.
	self benchmarks: benchs! !

!Rizel methodsFor: 'action' stamp: ''!
addBenchmark
	BenchmarkBrowser openOn: self! !

!Rizel methodsFor: 'accessing' stamp: ''!
benchmarks
	^ benchmarks! !

!Rizel methodsFor: 'accessing' stamp: ''!
benchmarks: t1 
	self benchmarks items: t1! !

!Rizel methodsFor: 'action' stamp: ''!
compare
	| t1 t2 t3 |
	t1 := model profile: profilePicker A second in: profilePicker A first.
	t2 := model profile: profilePicker B second in: profilePicker B first.
	t3 := profilePicker A first > profilePicker B first
				ifTrue: [RzProfile merge: t2 with: t1]
				ifFalse: [RzProfile merge: t1 with: t2].
	(RzVisualizerMerge on: t3) visualize! !

!Rizel methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	benchs := OrderedCollection new! !

!Rizel methodsFor: 'initialization' stamp: ''!
initializeWidgets
	versions := self instantiate: ListComposableModel.
	versions beMultipleSelection.
	benchmarks := self instantiate: ListComposableModel.
	benchmarks
		displayBlock: [:t1 | t1 asString].
	benchmarks beMultipleSelection.
	options := self instantiate: RizelOptions.
	options browser: self.
	roassal := self instantiate: RoassalModel! !

!Rizel methodsFor: 'accessing' stamp: ''!
model: t1 
	model := t1.
	self versions: model versions.
	versions displayBlock: model versionLabel! !

!Rizel methodsFor: 'accessing' stamp: ''!
options
	^ options! !

!Rizel methodsFor: 'action' stamp: 'JuanPabloSandovalA 8/19/2012 01:34'!
profile
	builder := RzBuilder new.

	builder
		define: #input
		named: #version
		with: self selectedVersions.
	builder
		define: #input
		named: #benchmark
		with: self selectedBenchmarks.
	result := builder
				execute: [:version :bench | 
					model loadVersion: version.
					[model executeBenchmark: [model perform: bench]] timeToRun].
	profilePicker := RzVisualizer2D new.
	profilePicker xValues: self selectedVersions;
		 yValues: self selectedBenchmarks;
		 xLabel: model versionLabel;
		yLabel: [:t1 | t1 asString];
		value: [:t1 :t2 | result at: RzVector <== t1 + t2];
		 padding: 100;
		 visualizeOn: self view.
	self view applyLayout.
	roassal update.! !

!Rizel methodsFor: 'accessing' stamp: ''!
roassal
	^ roassal! !

!Rizel methodsFor: 'accessing' stamp: ''!
selectedBenchmarks
	^ self benchmarks selectedItems asSortedCollection! !

!Rizel methodsFor: 'accessing' stamp: ''!
selectedVersions
	^ self versions selectedItems asSortedCollection! !

!Rizel methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/20/2012 00:50'!
validateBeforeProfile
	! !

!Rizel methodsFor: 'rizel' stamp: ''!
versionLabel: t1 
	versionLabel := t1! !

!Rizel methodsFor: 'accessing' stamp: ''!
versions
	^ versions! !

!Rizel methodsFor: 'accessing' stamp: ''!
versions: t1 
	self versions items: t1! !

!Rizel methodsFor: 'accessing' stamp: ''!
view
	^ roassal view! !

ComposableModel subclass: #RizelOptions
	instanceVariableNames: 'add profile compare browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RizelOptions class methodsFor: 'specs' stamp: ''!
defaultSpec
	<spec>
	^ {#Panel. #changeTableLayout. #listDirection:. #rightToLeft. #addMorph:. {#model. #profile. #defaultSpec}. #addMorph:. {#model. #compare. #defaultSpec}. #hResizing:. #spaceFill. #vResizing:. #shrinkWrap}! !

!RizelOptions class methodsFor: 'specs' stamp: ''!
title
	^ 'Rizel Options'! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
add
	add
		ifNil: [add := self instantiate: ButtonModel.
			add
				whenActionPerformedDo: [browser addBenchmark].
			add label: '+ bench'].
	^ add! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
browser
	^ browser! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
browser: t1 
	browser := t1! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
compare
	compare
		ifNil: [compare := self instantiate: ButtonModel.
			compare
				whenActionPerformedDo: [browser compare].
			compare label: 'Compare'].
	^ compare! !

!RizelOptions methodsFor: 'initialize-release' stamp: ''!
initializeWidgets
	^ self! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
profile
	profile
		ifNil: [profile := self instantiate: ButtonModel.
			profile
				whenActionPerformedDo: [browser profile].
			profile label: 'Profile'].
	^ profile! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
window
	^ window! !

!RizelOptions methodsFor: 'accessing' stamp: ''!
window: t1 
	window := t1! !

ComposableModel subclass: #RoassalModel
	instanceVariableNames: 'builder container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RoassalModel class methodsFor: 'as yet unclassified' stamp: ''!
defaultSpec
	^ {#ComposableSpec. #addMorphWrapper:. {#MorphWrapper. #morph:. {#model. #container}. #fullFrame:. {#LayoutFrame. #fractions:offsets:. 0 @ 0 corner: 1 @ 1. 2 @ 2 corner: 2 @ 2}}}! !

!RoassalModel class methodsFor: 'as yet unclassified' stamp: ''!
title
	^ 'RoassalSpec'! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: ''!
container
	^ container! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 8/19/2012 01:18'!
initializeWidgets
	| t1 |
	builder := ROMondrianViewBuilder new.
	t1 := ROViewStack new addView: builder view;
				 title: builder title.
	container := (ROMorph on: t1)
				extent: 300 @ 300.! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 8/19/2012 01:18'!
update
	container layoutChanged.! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: ''!
view
	^ builder! !
